package ec.app.sequence;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.io.FileUtils;

public class FastaFileChunker {
	
	public static void main(String[] args) {
		if(args.length <3){
			System.err.println("FastaFileChunker sourceSequenceFile(id,sequence,space) chunkSize outputFile needed");
			System.exit(-1);
		}
		try{
			//write the sequence file 
			File file = new File(args[2]);
			BufferedReader reader = new BufferedReader(new InputStreamReader(
					new FileInputStream(args[0])));
			//read the first line
			String totalLine = reader.readLine();
			int chunkSize = new Integer(args[1]).intValue();
			while (totalLine != null) {
				int startOfSpace = totalLine.indexOf(" ");
				String chromosomeId = totalLine.substring(0, startOfSpace);
				String sequence = totalLine.substring(startOfSpace + 1, totalLine
						.length());
				//chunk it to 162 length pieces
				List<String> chunks = splitEqually(chromosomeId,sequence,chunkSize);
				for(int k=0; k< chunks.size(); k++)
					FileUtil.writeStringToTextFile(file, chunks.get(k), true);
				totalLine = reader.readLine();
			}
		}catch(Exception e){
			e.printStackTrace();
		}
		
	}
	
	public static List<String> splitEqually(String prefix,String text, int size) {
	    // Give the list the right capacity to start with. You could use an array
	    // instead if you wanted.
	    List<String> ret = new ArrayList<String>((text.length() + size - 1) / size);
	    for (int start = 0; start < text.length(); start += size) {
	        ret.add(prefix + " " +text.substring(start, Math.min(text.length(), start + size)) + "\n");
	    }
	    return ret;
	}

}
