package ec.app.sequence;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.HashMap;

import org.apache.commons.io.FileUtils;
import org.biojava.bio.Annotation;
import org.biojava.bio.seq.Sequence;
import org.biojava.bio.seq.SequenceIterator;
import org.biojava.bio.seq.io.FastaFormat;
import org.biojava.bio.seq.io.SeqIOTools;

public class FastaParserGenomeLabelGenerator {
	
	
	
	public static void main(String[] args) {
		
		try{
		// get positive file name
		String positiveFileName = args[0];
		
		BufferedReader positiveBuffer;
			// read the files
			positiveBuffer = new BufferedReader(
					new FileReader(positiveFileName));

			SequenceIterator positiveFileIterator = (SequenceIterator) SeqIOTools
					.fileToBiojava("fasta", "DNA", positiveBuffer);
			ArrayList predictions = new ArrayList();
			int i=0 ;
			while(positiveFileIterator.hasNext()){
				Sequence fastaSequence = positiveFileIterator.nextSequence();
				Annotation annotations = fastaSequence.getAnnotation();
				String description = (String)annotations.getProperty(FastaFormat.PROPERTY_DESCRIPTIONLINE);
				//get the start of 
				String label= i+ "" ;
				if(description.contains("label=-1")){
					//negative
					label=  label + " -1";
				}
				else if(description.contains("label=1")){
					label=  label + " 1";
				} 
				i =i +1;
				predictions.add(label);				
			}
			FileUtils.writeLines(new File("predictionx.txt"), predictions);
		}catch(Exception e){
			e.printStackTrace();
		}
			
		}
	
	

}
